const path = require('path');
const fs = require('fs');
const docs = require('../../../../dist/libs/skolverket/docs.json');

// Core components that are not yet skolverketified
const blacklist = [
	'digi-calendar',
	'digi-calendar-week-view',
	'digi-form-filter',
	'digi-link-internal',
	'digi-link-external',
	'digi-navigation-context-menu',
	'digi-navigation-context-menu-item',
	'digi-navigation-sidebar',
	'digi-navigation-sidebar-button',
	'digi-navigation-vertical-menu',
	'digi-navigation-vertical-menu-item',
	'digi-progress-step',
	'digi-progress-steps',
	'digi-progressbar',
	'digi-tag',
	'digi-typography-meta'
];

const getComponentName = (component) => {
	const componentName = component.docsTags.find(
		(t) => t.name === 'swedishName'
	)?.text;
	return componentName;
};

const generateComponentTagsAndNamesData = () => {
	console.log('Generating component tags and names data...', docs);
	const componentTagsAndNamesData = docs.components
		.filter((component) => !blacklist.includes(component.tag))
		.map((component) => {
			return {
				tag: component.tag,
				name: getComponentName(component)
			};
		});

	console.log(
		'Component tags and names data generated',
		componentTagsAndNamesData
	);
	writeComponentTagsAndNamesDataToFile(componentTagsAndNamesData);
};

const writeComponentTagsAndNamesDataToFile = (componentTagsAndNames) => {
	const fileName = path.join(
		__dirname,
		'global',
		'routes',
		'componentTagsAndNames.generated.ts'
	);
	console.log('Writing component routes to file...');
	fs.writeFileSync(
		fileName,
		`// Autogenerated file \n\n export type ComponentTag = ${componentTagsAndNames
			.map((c) => `'${c.tag}'`)
			.join(' | ')}\n\n export type ComponentName = ${componentTagsAndNames
			.map((c) => `'${c.name}'`)
			.join(
				' | '
			)}\n\n export const componentTagsAndNames: { tag: ComponentTag; name?: ComponentName }[] = ${JSON.stringify(
			componentTagsAndNames,
			null,
			1
		)}`,
		{ encoding: 'utf8', flag: 'w' }
	);
	console.log('Component tags and names data written to file! ' + fileName);
};

generateComponentTagsAndNamesData();
